################################################################################
#    glue.pl - This file is part of lilprox
#    Copyright (C) 2004 Arne Bochem <lilprox@arneb.de>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
################################################################################
# This file contains dummy subs. Please take care not to remove any of them.
# You probably want to change them, though.

# Might be used to buffer the content, sent by server.
use vars qw($buffer);

# Header as sent by the client.
sub client_header
{
	my $text = shift;

	# Kill stuff that could keep connections alive. >:]
	$text =~ s/\nConnection: .*\n/\n/g;
	$text =~ s/\n.*keep-alive.*\n/\n/g;

	# Kill auth creds in URLs
	$text =~ s#http://[a-z0-9]*:[a-z0-9]*@(.*?)/#http://$1/#i;

	# Show URLs...
	#$text =~ /(http.*) /;
	#print "$1\n";

	return($text);
}

# Content as sent by the client. 
sub client_content
{
	return($_[0]);
}

# Proxy processed request from client, ready to be sent to the remote server.
sub client_request
{
	return($_[0]);
}

# Argument is the header, sent by remote server.
# (You probably want to buffer this for Content-Length fixes...)
sub server_header
{
	return($_[0]);
}

# For performance reasons, this function gets 1024 byte chunks. You might want
# to write your own buffer and return empty strings, if you want to do stuff
# with the whole document at once. (Use globals.)
sub server_content
{
	#print $_[0];
	#print "Buffer: ".(++$buffer)."\n";
	return($_[0]);
}

# Is called after getting all the content and return value is sent to client.
# (Probably useful to send stuff from a buffer.)
sub server_post
{
	return('');
}
